package com.gic.haoban.manage.api.service;

import com.gic.api.base.commons.Page;
import com.gic.haoban.base.api.common.BasePageInfo;
import com.gic.haoban.base.api.common.ServiceResponse;
import com.gic.haoban.manage.api.dto.PreDealLogInfoDTO;
import com.gic.haoban.manage.api.dto.SyncCheckDTO;
import com.gic.haoban.manage.api.dto.SyncSingleDealDTO;
import com.gic.haoban.manage.api.dto.SyncTaskDTO;

import java.util.List;

/**
 * Created 2020/4/9.
 *
 * @author hua
 */
public interface DealSyncOperationApiService {

    /**
     * 部门同步处理
     *
     * @param params
     */
    public void departmentDealMq(String params);

    /**
     * 处理前端数据
     *
     * @param addList
     * @param editList
     */
    public void dealDepartment(String taskId, String wxEnterpriseId, List<SyncSingleDealDTO> addList, List<SyncSingleDealDTO> editList);

    /**
     * 重新执行任务
     *
     * @param taskId
     */
    public void reDealDepartment(String taskId, int dataType);

    /**
     * 创建任务
     *
     * @param taskName
     * @param userId
     * @param desc
     */
    public String createTask(String wxEnterpriseId, String taskName, String userId, String desc);

    /**
     * 创建任务
     *
     * @param taskName
     * @param userId
     * @param desc
     */
    public String createQywxTask(String wxEnterpriseId, String taskName, String userId, String desc);

    /**
     * 关闭任务
     *
     * @param wxEnterpriseId
     * @return
     */
    public boolean closeTask(String wxEnterpriseId);


    /**
     * 解锁
     *
     * @param taskId
     */
    public void unlockTask(String taskId);

    /**
     * 校验是否锁
     *
     * @param wxEnterpriseId
     * @return
     */
    public String getTaskLock(String wxEnterpriseId);

    /**
     * 校验同步状态
     *
     * @param wxEnterpriseId
     * @return
     */
    public SyncCheckDTO getTaskCheck(String wxEnterpriseId);

    /**
     * 同步日志
     *
     * @param wxEnterpriseId
     * @return
     */
    public Page<SyncTaskDTO> listSyncTask(String wxEnterpriseId, BasePageInfo pageInfo);

    /**
     * 同步日志
     *
     * @param wxEnterpriseId
     * @return
     */
    public Page<PreDealLogInfoDTO> listSyncTaskDetail(String wxEnterpriseId, String taskId, BasePageInfo pageInfo);


    /**
     * 处理同步
     */
    public String dealQywxDepartment(String taskId, String wxEnterpriseId);

    /**
     * 清理不存在的数据
     * @param wxEnterpriseId
     * @param taskId
     */
    public void  cleanDiffrence(String wxEnterpriseId,String taskId);
    /**
     * 创建企业微信好友刷新任务
     * @param wxEnterpriseId
     * @param taskName
     * @param staffId
     * @param desc
     * @return
     */
	public String createWxFriendTask(String wxEnterpriseId, String taskName, String staffId, String desc);
	/**
	 * 处理需要处理的导购
	 * @param taskId
	 * @param wxEnterpriseId
	 */
	public void dealWxFriendClerk(String taskId, String wxEnterpriseId);
	/**
     * 创建企业微信好友刷新任务
     * @param wxEnterpriseId
     * @param taskName
     * @param staffId
     * @return
     */
    public String createWxFriendTaskSingle(String wxEnterpriseId, String taskName, String staffId, String staffName, int syncTaskType);

	/**
	 * 单个导购刷新
	 * @param taskId
	 * @param wxUserId
	 * @param staffId
	 * @param wxEnterpriseId
	 */
	public void dealWxFriendClerkSingle(String taskId, String wxUserId, String staffId,String wxEnterpriseId);

    /**
     * 单个导购刷新
     *
     * @param taskId
     * @param wxEnterpriseId
     */
    public void dealWxFriendStore(String taskId, String storeId, String wxEnterpriseId);

    /**
	 * 定时
	 * @param res
	 */
	public void quartWxFriendClerk(String res);

	void test(String wxEnterpriseId, String taskId);
}
