package com.gic.haoban.manage.api.service;

import java.util.List;
import java.util.Set;

import com.gic.haoban.base.api.common.BasePageInfo;
import com.gic.haoban.manage.api.dto.QywxCorpInfoSimpleDTO;
import com.gic.haoban.manage.api.dto.SecretSettingDTO;
import com.gic.haoban.manage.api.dto.WxEnterpriseDTO;
import com.gic.haoban.manage.api.dto.YwWxEnterpriseDTO;

public interface WxEnterpriseApiService {

	/**
	 * 接收企业回调信息
	 * @param dto
	 */
	void callbackReviceEnterprise(QywxCorpInfoSimpleDTO dto);
	/**
	 * 运维后台获取微信企业id列表
	 * @return
	 */
	com.gic.api.base.commons.Page<YwWxEnterpriseDTO> list(BasePageInfo pageInfo,String keyword,List<String> enterpriseIds,Integer gicContactFlag,String version);
	/**
	 * 获取一个
	 * @param wxEnterpriseId
	 * @return
	 */
	WxEnterpriseDTO getOne(String wxEnterpriseId);

	WxEnterpriseDTO getEnterpriseBycorpId(String corpId);
	/**
	 * 更新企业
	 * @param enterpriseDTO
	 */
	void update(WxEnterpriseDTO enterpriseDTO);
	
	List<YwWxEnterpriseDTO> listAll();
	
	List<YwWxEnterpriseDTO> listByIds(Set<String> enterpriseIds);
	
	boolean enterpriseIsOver(String enterpriseId);

	/**
	 * 获取配置
	 * @param wxEnterpriseId
	 * @param secretType
	 * @param enterpriseId
	 * @return
	 */
	public SecretSettingDTO getSecretSetting(String wxEnterpriseId,int secretType,String enterpriseId);

	/**
	 * 保存
	 * @param secretSettingDTO
	 * @return
	 */
	public boolean saveSecretSetting(SecretSettingDTO secretSettingDTO);

	/**
	 * secretList
	 * @param wxEnterpriseId
	 * @return
	 */
	List<SecretSettingDTO> listSecret(String wxEnterpriseId);

	/**
	 * 删除
	 * @param secretId
	 * @return
	 */
	public boolean delSecretSetting(String secretId);
}
