package com.gic.haoban.manage.api.service;

import java.util.Date;
import java.util.List;

import com.gic.api.base.commons.Page;
import com.gic.haoban.base.api.common.BasePageInfo;
import com.gic.haoban.manage.api.dto.*;

public interface WxEnterpriseRelatedApiService {
	List<EnterpriseDetailDTO> listEnterpriseByWxEnterpriseId(String wxEnterpriseId);
	
	int  wxEnterpriseBind(String enterpriseId,String wxEnterpriseId,String version);
	
	String getGicEnterpriseIdByEnterpriseRelatedId(String wxEnterpriseRelatedId);

	boolean enterpriseUseNew(String enterpriseId);

	EnterpriseDetailDTO getByEnterpriseId(String enterpriseId);

	List<EnterpriseDetailDTO> queryAllHasGicEnterpriseId();
	
	List<EnterpriseDetailDTO> listEnterpriseByEnterpriseIds(List<String> enterpriseIds);

	/**
	 * 返回在一定时期内的信息
	 * @return
	 */
	List<EnterpriseDetailDTO> queryBindGicEnterpriseByTime(String seqTime);

	@Deprecated
	int wxEnterpriseBind(String enterpriseId, String wxEnterpriseId, String version, String staffId, String staffName);

	/**
	 * 企业绑定
	 *
	 * @param detailDTO
	 * @return
	 */
	int wxEnterpriseBind(WxEnterpriseRelationDetailDTO detailDTO);

	/**
	 * 刷新企业门店
	 *
	 * @param enterpriseId
	 * @param wxEnterpriseId
	 * @param staffId
	 * @return
	 */
	public boolean flushBindStoreByEnterpriseId(String enterpriseId, String wxEnterpriseId, String staffId);

	/**
	 * 获取企业绑定详情
	 *
	 * @param wxEnterpriseId
	 * @param enterpriseId
	 * @return
	 */
	public WxEnterpriseRelationDetailDTO getEnterpriseBindInfo(String wxEnterpriseId, String enterpriseId);

	/**
	 * 根据商户id 获取关联的微信企业列表
	 *
	 * @param enterpriseId
	 * @return
	 */
	public List<WxEnterpriseDTO> listWxEnterpriseByEid(String enterpriseId);

	/**
	 * @param enterpriseId
	 * @param search
	 * @param pageInfo
	 * @return
	 */
	public Page<BindStoreInfoDTO> pageBindStoreByEnterpriseId(String wxEnterpriseId, String enterpriseId, String search, BasePageInfo pageInfo);

}
