package com.gic.haoban.manage.service.service;

import java.util.List;

import com.gic.haoban.manage.api.dto.ExternalClerkRelatedDTO;
import com.gic.haoban.manage.api.dto.MemberUnionidRelatedDTO;
import com.gic.haoban.manage.service.entity.TabHaobanExternalClerkRelated;

public interface ExternalClerkRelatedService {

	void insert(TabHaobanExternalClerkRelated related);

	void delByUserIdAndExternalUserId(MemberUnionidRelatedDTO dto);

	/**
	 * 删除会员与导购的关联关系
	 *
	 * @param wxEnterpriseId
	 * @param wxUserId
	 * @param externalUserids
	 */
	void delByUserIdAndExternalUserIdBatch(String wxEnterpriseId, String wxUserId, List<String> externalUserids);

	void delByClerkIdAndStaffId(String clerkId, String staffId);

	void cleanStaffRelated(String wxEnterpriseId, List<String> staffIds);

	void update(TabHaobanExternalClerkRelated exsitDTO);

	TabHaobanExternalClerkRelated getByParams(String userId, String wxEnterpriseId, String name, String createTime);

	List<TabHaobanExternalClerkRelated> listByExTernalUseridAndWxUserId(String externalUserid, String wxUserId);

	ExternalClerkRelatedDTO getByMemberId(String wxUserId, String memberId);

	/**
	 * 根据unionid获取外部联系人的绑定导购
	 *
	 * @param enterpriseId
	 * @param unionId
	 * @return
	 */
	List<TabHaobanExternalClerkRelated> listExternalByUnionId(String enterpriseId, String unionId);

}
