package com.gic.haoban.manage.service.service.out.impl;

import cn.hutool.core.collection.CollectionUtil;

import com.alibaba.fastjson.JSONObject;
import com.gic.api.base.commons.Page;
import com.gic.clerk.api.dto.ClerkDTO;
import com.gic.clerk.api.service.ClerkNewService;
import com.gic.clerk.api.service.ClerkService;
import com.gic.commons.util.EntityUtil;
import com.gic.enterprise.api.dto.EnterpriseDTO;
import com.gic.enterprise.api.dto.StoreDTO;
import com.gic.enterprise.api.service.EnterpriseService;
import com.gic.enterprise.api.service.StoreService;
import com.gic.haoban.base.api.common.BasePageInfo;
import com.gic.haoban.base.api.common.ServiceResponse;
import com.gic.haoban.manage.api.dto.*;
import com.gic.haoban.manage.api.enums.AuditType;
import com.gic.haoban.manage.api.enums.BindTypeEnum;
import com.gic.haoban.manage.api.enums.ChannelCodeEnum;
import com.gic.haoban.manage.api.enums.SecretTypeEnum;
import com.gic.haoban.manage.api.service.AuditApiService;
import com.gic.haoban.manage.api.service.StaffClerkRelationApiService;
import com.gic.haoban.manage.service.dao.mapper.TabHaobanStaffClerkRelationMapper;
import com.gic.haoban.manage.service.entity.*;
import com.gic.haoban.manage.service.entity.TabHaobanStaff;
import com.gic.haoban.manage.service.service.*;

import com.gic.wechat.api.dto.qywx.QywxExternalcontactDTO;
import com.gic.wechat.api.service.qywx.QywxUserApiService;
import org.apache.commons.collections.CollectionUtils;
import org.apache.commons.lang3.StringUtils;
import org.apache.ibatis.annotations.Param;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.*;
import java.util.stream.Collectors;

@Service
public class StaffClerkRelationApiServiceImpl implements StaffClerkRelationApiService {

	private static final Logger logger= LoggerFactory.getLogger(StaffClerkRelationApiServiceImpl.class);

	@Autowired
	private StaffClerkRelationService staffClerkRelatinService;

	@Autowired
	private EnterpriseService enterpriseService;

	@Autowired
	private ClerkService clerkService;

	@Autowired
	private StoreService storeService;
	@Autowired
	private TabHaobanStaffClerkRelationMapper tabHaobanStaffClerkRelationMapper;

	@Autowired
	private AuditApiService auditApiService;

	@Autowired
	private ClerkMainStoreRelatedService clerkMainStoreRelatedService;

	@Autowired
	private StaffClerkBindLogService staffClerkBindLogService;

	@Autowired
	private WxEnterpriseRelatedService wxEnterpriseRelatedService;

	@Autowired
	private ClerkNewService clerkNewService;

	@Autowired
	private StaffService staffService;
	
	@Autowired
	private ExternalClerkRelatedService externalClerkRelatedService;

	@Autowired
	private QywxUserApiService qywxUserApiService;

	@Autowired
	private SecretSettingService secretSettingService;

	@Autowired
	private WxEnterpriseService wxEnterpriseService;

	@Override
	public void bindLogMq(String params) {
		logger.info("绑定日志mq:{}",params);
		StaffClerkBindLogInfoDTO infoDTO = JSONObject.parseObject(params, StaffClerkBindLogInfoDTO.class);
		if (null == infoDTO){
			logger.info("数据不存在");
			return;
		}
		TabHaobanStaffClerkRelation clerkRelation = tabHaobanStaffClerkRelationMapper.selectByPrimaryKey(infoDTO.getRelationId());
		if (null == clerkRelation) {
			logger.info("不存在绑定数据");
			return;
		}
		ClerkDTO clerkDTO = clerkService.getClerkByClerkIdNoStatus(clerkRelation.getClerkId());
		String phoneNumber="";
		if (null != clerkDTO) {
			phoneNumber=clerkDTO.getPhoneNumber();
		}
		TabHaobanStaffClerkBindLog staffClerkRelation=new TabHaobanStaffClerkBindLog();
		staffClerkRelation.setClerkId(clerkRelation.getClerkId());
		staffClerkRelation.setChannelCode(infoDTO.getChannelCode());
		staffClerkRelation.setClerkCode(clerkRelation.getClerkCode());
		staffClerkRelation.setCreateTime(new Date());
		staffClerkRelation.setEnterpriseId(clerkRelation.getEnterpriseId());
		staffClerkRelation.setOptStaffId(infoDTO.getOptStaffId());
		staffClerkRelation.setOptType(infoDTO.getOptType());
		staffClerkRelation.setStatusFlag(1);
		staffClerkRelation.setStaffId(clerkRelation.getStaffId());
		staffClerkRelation.setWxEnterpriseId(clerkRelation.getWxEnterpriseId());
		staffClerkRelation.setRelationId(infoDTO.getRelationId());
		staffClerkRelation.setClerkPhone(phoneNumber);
		staffClerkRelation.setUpdateTime(new Date());

		staffClerkBindLogService.insert(staffClerkRelation);

	}

	@Override
	public List<StaffClerkRelationDTO> listBindCode(String enterpriseId, Set<String> clerkCodeList) {
		return staffClerkRelatinService.listBindCode(enterpriseId,clerkCodeList);
	}
	@Override
	public List<StaffClerkRelationDTO> listBindCodeByStaffId(List<String> enterpriseIdList, String staffId) {
		return staffClerkRelatinService.listBindCodeByStaffId(enterpriseIdList,staffId);
	}

	@Override
	public List<StaffClerkInfoDTO> listBindDetailByStaffId(String staffId) {
		List<StaffClerkRelationDTO> list = staffClerkRelatinService.listBindCodeByStaffId(null, staffId);
		if (CollectionUtils.isEmpty(list)) {
			return null;
		}
		List<StaffClerkInfoDTO> infoDTOS = EntityUtil.changeEntityListByJSON(StaffClerkInfoDTO.class, list);
		Map<String,String> nameMap=new HashMap<>();
		infoDTOS.forEach(infoDTO->{
			//企业
			if (!nameMap.containsKey(infoDTO.getEnterpriseId())) {
				EnterpriseDTO enterpriseDTO = enterpriseService.getEnterpriseById(infoDTO.getEnterpriseId());
				if (null != enterpriseDTO) {
					nameMap.put(infoDTO.getEnterpriseId(),enterpriseDTO.getEnterpriseName());
				}else{
					nameMap.put(infoDTO.getEnterpriseId(),"未知商户");
				}
			}
			//门店店员名称
			if (!nameMap.containsKey(infoDTO.getClerkId())) {
				ClerkDTO clerkDTO = clerkService.getClerkByClerkId(infoDTO.getClerkId());
				if (null != clerkDTO) {
					nameMap.put(infoDTO.getClerkId(),clerkDTO.getClerkName());
					nameMap.put(infoDTO.getStoreId(),clerkDTO.getStoreName());
					infoDTO.setClerkPhoneNumber(clerkDTO.getPhoneNumber());
				}else{
					nameMap.put(infoDTO.getEnterpriseId(),"未知店员");
				}
			}

			//门店店员名称
			if (!nameMap.containsKey(infoDTO.getStoreId())) {
				StoreDTO storeDTO = storeService.getStore(infoDTO.getStoreId());
				if (null != storeDTO) {
					nameMap.put(infoDTO.getStoreId(),storeDTO.getStoreName());
				}else{
					nameMap.put(infoDTO.getStoreId(),"未知门店");
				}
			}

			infoDTO.setClerkName(nameMap.get(infoDTO.getClerkId()));
			infoDTO.setStoreName(nameMap.get(infoDTO.getStoreId()));
			infoDTO.setEnterpriseName(nameMap.get(infoDTO.getEnterpriseId()));
		});
		return infoDTOS;
	}

	@Override
	public ServiceResponse bindStaffClerk(StaffClerkRelationDTO staffClerkRelationDTO,String optStaffId,int chanelCode) {
		logger.info("绑定clerk:{}", JSONObject.toJSONString(staffClerkRelationDTO));
		ServiceResponse<Object> response = new ServiceResponse<>();
		StaffClerkRelationDTO relationDTO = staffClerkRelatinService.getBindByClerkId(staffClerkRelationDTO.getClerkId(), staffClerkRelationDTO.getWxEnterpriseId());
		if (null!=relationDTO) {
			response.setCode(2);
			response.setMessage("已经被绑定，不能绑定");
			return response;
		}
		AuditDTO auditDTO = auditApiService.findByBindRelatedIdAndAuditType(staffClerkRelationDTO.getClerkId(), AuditType.CLERK_BIND.getCode());
		if (null != auditDTO) {
			response.setCode(4);
			response.setMessage("该导购已经被被申请绑定，请审核处理后再绑定");
			return response;
		}
		List<AuditDTO> list = auditApiService.listByStoreId(staffClerkRelationDTO.getStoreId());
		if (CollectionUtils.isNotEmpty(list)) {
			Set<String> staffIds = list.stream().map(AuditDTO::getCommitStaffId).collect(Collectors.toSet());
			if (staffIds.contains(staffClerkRelationDTO.getStaffId())) {
				response.setCode(5);
				response.setMessage("该成员已经已经在该门店下申请了绑定，请审核处理后再绑定");
				return response;
			}
		}
		StaffClerkRelationDTO storeHasBind = staffClerkRelatinService.getOneBindByStoreId(staffClerkRelationDTO.getStaffId(), staffClerkRelationDTO.getStoreId());
		if (storeHasBind!=null) {
			response.setCode(3);
			response.setMessage("该导购已在该门店下有其它成员绑定");
			return response;
		}

		String relationId = staffClerkRelatinService.bind(staffClerkRelationDTO,optStaffId,chanelCode);
		response.setResult(relationId);
		return response;
	}
	
	@Override
	public StaffClerkRelationDTO getByCodeAndEnterpriseId(String clerkCode, String enterpriseId) {
		return staffClerkRelatinService.getByCodeAndEnterpriseId(clerkCode,enterpriseId);
	}


	@Override
	public String delByStoreIdAndCode(String storeId, String clerkCode) {
		TabHaobanStaffClerkRelation staffClerkRelation = tabHaobanStaffClerkRelationMapper.getByCodeAndStoreId(clerkCode, storeId);
		tabHaobanStaffClerkRelationMapper.delByStoreIdAndCode(storeId,clerkCode);
		delSetMainStore(staffClerkRelation);
		return null;
	}
	@Override
	public List<StaffClerkRelationDTO> listByClerkIds(List<String> clerkIds) {
		if(clerkIds == null || clerkIds.isEmpty()){
			return Collections.EMPTY_LIST;
		}
		List<TabHaobanStaffClerkRelation> list = tabHaobanStaffClerkRelationMapper.listByClerkIds(clerkIds);
		if(CollectionUtil.isEmpty(list)){
			return new ArrayList<StaffClerkRelationDTO>();
		}
		List<StaffClerkRelationDTO> result = EntityUtil.changeEntityListByJSON(StaffClerkRelationDTO.class, list);
		return result;
	}
	@Override
	public List<StaffClerkRelationDTO> listByStoreId(String storeId) {
		List<TabHaobanStaffClerkRelation> list = tabHaobanStaffClerkRelationMapper.listByStoreId(storeId);
		if(CollectionUtil.isEmpty(list)){
			return new ArrayList<StaffClerkRelationDTO>();
		}
		List<StaffClerkRelationDTO> result = EntityUtil.changeEntityListByJSON(StaffClerkRelationDTO.class, list);
		return result;	
	}

	@Override
	public boolean unbindByStaffAndClerkId(String staffId, String clerkId) {
		boolean b = staffClerkRelatinService.delBind(clerkId,staffId, ChannelCodeEnum.ADMIN_UNBIND.getCode());
		return b;
	}
	@Override
	public StaffClerkRelationDTO getOneByClerkId(String clerkId) {
		TabHaobanStaffClerkRelation tab = tabHaobanStaffClerkRelationMapper.getOneByClerkId(clerkId);
		StaffClerkRelationDTO result = EntityUtil.changeEntityByJSON(StaffClerkRelationDTO.class, tab);
		return result;
	}
	public StaffClerkRelationDTO getByClerkId(String clerkId) {
		StaffClerkRelationDTO staffRelation = staffClerkRelatinService.getByClerkId(clerkId);
		return staffRelation;
	}
	@Override
	public StaffClerkRelationDTO getOneByStoreIdAndStaffId(String storeId,
			String staffId) {
		TabHaobanStaffClerkRelation tab  = tabHaobanStaffClerkRelationMapper.getOneByStoreIdAndStaffId(storeId,staffId);
		if(tab == null){
			return null;
		}
		StaffClerkRelationDTO dto = EntityUtil.changeEntity(StaffClerkRelationDTO.class, tab);
		return dto;
	}
	@Override
	public void delAndInsert(StaffClerkRelationDTO staffClerkRelation,String optStaffId,int chanelCode) {
		if(StringUtils.isNotBlank(staffClerkRelation.getStaffClerkRelationId())){
			TabHaobanStaffClerkRelation oldStaffClerkRelation = tabHaobanStaffClerkRelationMapper.selectByPrimaryKey(staffClerkRelation.getStaffClerkRelationId());
			tabHaobanStaffClerkRelationMapper.delByPrimaryKey(staffClerkRelation.getStaffClerkRelationId());
			staffClerkBindLogService.pushToMq(oldStaffClerkRelation.getStaffId(),optStaffId, BindTypeEnum.UNBIND.getVal(),chanelCode,staffClerkRelation.getStaffClerkRelationId());
		}
		String relationId = staffClerkRelatinService.insert(staffClerkRelation);
		staffClerkBindLogService.pushToMq(staffClerkRelation.getStaffId(),optStaffId, BindTypeEnum.BIND.getVal(),chanelCode,relationId);
		//设置主门店
		setMainStore(staffClerkRelation);
	}
	@Override
	public void delByClerkId(String clerkId) {
		TabHaobanStaffClerkRelation staffClerkRelation = tabHaobanStaffClerkRelationMapper.getOneByClerkId(clerkId);
		tabHaobanStaffClerkRelationMapper.delByClerkId(clerkId);
		delSetMainStore(staffClerkRelation);
	}
	@Override
	public List<StaffClerkRelationDTO> listByEnterpriseIdAndWxUserId(String enterpriseId,String wxUserId) {
		List<TabHaobanStaffClerkRelation> list = tabHaobanStaffClerkRelationMapper.listByEnterpriseIdAndWxUserId(enterpriseId,wxUserId);
		return  EntityUtil.changeEntityListByJSON(StaffClerkRelationDTO.class, list);
	}

	@Override
	public Page<StaffClerkBindLogDetailDTO> pageStaffClerkBindLog(String wxEnterpriseId, String search, String enterpriseId, int optType, BasePageInfo pageInfo) {

		List<TabHaobanWxEnterpriseRelated> wxEnterpriseRelateds = wxEnterpriseRelatedService.getByWxEnterpriseId(wxEnterpriseId);
		if (CollectionUtils.isEmpty(wxEnterpriseRelateds)) {
			logger.info("没有关联企业");
			return null;
		}
		List<String> enterpriseList = wxEnterpriseRelateds.stream().map(TabHaobanWxEnterpriseRelated::getEnterpriseId)
				.filter(eid->{
					if (StringUtils.isBlank(enterpriseId)) {
						return true;
					}else if (enterpriseId.equals(eid)) {
						return true;
					}else{
						return false;
					}
				}).collect(Collectors.toList());
		if (CollectionUtils.isEmpty(enterpriseList)) {
			logger.info("没有有效的企业");
			return null;
		}
		List<String> clerkIds=null;
//		if (StringUtils.isNotBlank(search)) {
//			List<ClerkDTO> clerk = clerkNewService.listClerkByEnterpriseIdAndSearch(enterpriseList, search);
//			if (CollectionUtils.isEmpty(clerk)) {
//				logger.info("没有搜索到相应信息");
//				return new Page<StaffClerkBindLogDetailDTO>();
//			}
//			clerkIds = clerk.stream().map(ClerkDTO::getClerkId).collect(Collectors.toList());
//		}
		Page<StaffClerkBindLogDetailDTO> retList = staffClerkBindLogService.pageBindLog(wxEnterpriseId, clerkIds, null, enterpriseList, optType,search, pageInfo);
		if (CollectionUtils.isNotEmpty(retList.getResult())) {
			retList.getResult().forEach(staffClerkBindLogDetailDTO -> {
				TabHaobanStaff haobanStaff = staffService.selectById(staffClerkBindLogDetailDTO.getStaffId());
				if (null !=haobanStaff) {
					staffClerkBindLogDetailDTO.setStaffName(haobanStaff.getStaffName());
					staffClerkBindLogDetailDTO.setWxUserId(haobanStaff.getWxUserId());
				}else{
					staffClerkBindLogDetailDTO.setStaffName("未知成员");
				}
				if ("-1".equals(staffClerkBindLogDetailDTO.getOptStaffId())) {
					staffClerkBindLogDetailDTO.setOptStaffName("系统");
				}else {
					haobanStaff = staffService.selectById(staffClerkBindLogDetailDTO.getOptStaffId());
					if (null != haobanStaff) {
						staffClerkBindLogDetailDTO.setOptStaffName(haobanStaff.getStaffName());
					} else {
						staffClerkBindLogDetailDTO.setOptStaffName("未知成员");
					}
				}

				ClerkDTO clerkDTO = clerkService.getClerkByClerkIdNoStatus(staffClerkBindLogDetailDTO.getClerkId());
				if (null != clerkDTO) {
					staffClerkBindLogDetailDTO.setClerkName(clerkDTO.getClerkName());
				}
				staffClerkBindLogDetailDTO.setClerkPhoneNumber(staffClerkBindLogDetailDTO.getClerkPhone());
			});
		}
		return retList;
	}

	@Override
	public void pushToBindLog(String staffId, String optStaffId, int optType, int channelCode, String relationId) {
		staffClerkBindLogService.pushToMq(staffId,optStaffId,optType,channelCode,relationId);
	}

	private void setMainStore(StaffClerkRelationDTO staffClerkRelation){
		 if(staffClerkRelation == null){
			 logger.info("staffClerkRelation为空");
			 return;
		 }
		 String staffId = staffClerkRelation.getStaffId();
		 String wxEnterpriseId = staffClerkRelation.getWxEnterpriseId();
		 List<StaffClerkRelationDTO> list = staffClerkRelatinService.lisByStaffId(wxEnterpriseId, staffId);
		 if(list != null && list.size() == 1){
			 clerkMainStoreRelatedService.setMainStore(staffId, staffClerkRelation.getStoreId(), wxEnterpriseId);
		 }
	}

	private void delSetMainStore(TabHaobanStaffClerkRelation staffClerkRelation){
		 if(staffClerkRelation == null){
			 logger.info("staffClerkRelation为空");
			 return;
		 }
		 String staffId = staffClerkRelation.getStaffId();
		 String wxEnterpriseId = staffClerkRelation.getWxEnterpriseId();
		 TabHaobanClerkMainStoreRelated r = clerkMainStoreRelatedService.selectByWxEnterpriseIdAndStoreId(staffId, wxEnterpriseId);
		 r.setStatusFlag(0);
		 clerkMainStoreRelatedService.update(r);
		 externalClerkRelatedService.delByClerkIdAndStaffId(staffClerkRelation.getClerkId(), staffId);
		 List<StaffClerkRelationDTO> list = staffClerkRelatinService.lisByStaffId(wxEnterpriseId, staffId);
		 if(list != null && list.size() >= 1){
			 clerkMainStoreRelatedService.setMainStore(staffId, list.get(list.size()-1).getStoreId(), wxEnterpriseId);
		 }
	}

	@Override
	public ServiceResponse<String> getClerkMemberChatConfig(String clerkId) {

		ServiceResponse response=new ServiceResponse();
		StaffClerkRelationDTO relationDTO = staffClerkRelatinService.getByClerkId(clerkId);
		if (null == relationDTO) {
			logger.info("导购没有关联企业微信：{}",clerkId);
			response.setCode(2);
			response.setMessage("导购没有关联企业微信");
			return response;
		}

		MemberClerkChatConfig chatConfig = staffClerkRelatinService.getChatConfig(relationDTO.getStaffId(), "-1");
		if (chatConfig!=null) {
			response.setResult(chatConfig.getConfigId());
			return response;
		}

		QywxExternalcontactDTO send = new QywxExternalcontactDTO();
		send.setType(1);
		send.setScene(1);
		send.setRemark("导购:" + relationDTO.getClerkCode());
		List<String> userIds = new ArrayList<>();
		userIds.add(relationDTO.getWxUserId());
		send.setUser(userIds);


		SecretSettingDTO secretSetting = secretSettingService.getSecretSetting(relationDTO.getWxEnterpriseId(), SecretTypeEnum.HAOBAN_HELP.getVal());
		if (null == secretSetting||secretSetting.getCheckFlag()==0) {
			logger.info("没有配置secret:{}",relationDTO.getWxEnterpriseId());
			response.setCode(3);
			response.setMessage("企业微信配置异常");
			return response;
		}
		WxEnterpriseDTO enterpriseDTO = wxEnterpriseService.selectById(relationDTO.getWxEnterpriseId());
		String configId = qywxUserApiService.getExternalcontactByUserId(enterpriseDTO.getCorpid(), secretSetting.getSecretVal(), send);
		logger.info("configId:{}",configId);
		if (StringUtils.isBlank(configId)) {
			logger.info("staff:{}", configId, JSONObject.toJSONString(relationDTO));
			response.setCode(4);
			response.setMessage("创建config失败");
			return response;
		}
		MemberClerkChatConfig clerkChatConfig = new MemberClerkChatConfig();
		clerkChatConfig.setConfigId(configId);
		clerkChatConfig.setEnterpriseId(relationDTO.getEnterpriseId());
		clerkChatConfig.setMemberId("-1");
		clerkChatConfig.setStaffId(relationDTO.getStaffId());
		staffClerkRelatinService.saveChatConfig(clerkChatConfig);

		response.setResult(clerkChatConfig.getConfigId());
		return response;
	}

	@Override
	public Page<StaffClerkRelationDTO> pageByWxEnterpriseId(String wxEnterpriseId, BasePageInfo pageInfo) {
		return staffClerkRelatinService.pageByWxEnterpriseId(wxEnterpriseId,pageInfo);
	}
}
